<template>
  <div id="jobTemplate">
    <search-box :formList="formList" @search="search" @init="init" />
    <table-list
      :tableSets="tableSet"
      :tableData="tableData"
      :navText="navText"
      @addClick="addClick"
      :loading="loading"
    >
      <template slot="btn" slot-scope="props">
        <el-button type="text" @click="addClick(props.scope.row, 2)"
          >详情</el-button
        >
        <el-button type="text" @click="addClick(props.scope.row, 0)"
          >修改</el-button
        >
        <el-button type="text" @click="del(props.scope.row)">删除</el-button>
      </template>
    </table-list>
    <pagination
      :total="total"
      :pageSize="pageSize"
      :currentPage="currentPage"
      @handleSizeChange="handleSizeChange"
      @handleCurrentChange="handleCurrentChange"
    />
    <el-dialog
      :visible.sync="dialogVisible"
      width="600px"
      :show-close="false"
      :before-close="close"
    >
      <div slot="title" class="hearders">
        <div class="leftTitle">
          {{ statusPop === 1 ? "添加" : statusPop === 0 ? "修改" : "详情" }}
        </div>
        <div class="rightBoxs">
          <img src="@/assets/images/Close@2x.png" alt="" @click="close" />
        </div>
      </div>
      <div>
        <el-form
          label-position="right"
          label-width="120px"
          :model="listData"
          :rules="rules"
          ref="listData"
        >
          <el-form-item
            v-for="(items, indexs) in listitem"
            :key="indexs"
            :label="items.label"
            :prop="items.prop"
          >
            <el-radio-group
              v-if="items.scope === 'radio'"
              v-model="listData[items.prop]"
            >
              <el-radio
                v-for="(item, index) in items.options"
                :key="index"
                :label="item.value"
                :disabled="statusPop === 2"
                >{{ item.label }}</el-radio
              >
            </el-radio-group>
            <el-input
              :disabled="statusPop === 2"
              v-else-if="items.scope === 'textarea'"
              type="textarea"
              v-model="listData[items.prop]"
            ></el-input>
            <el-select
              :placeholder="items.placeholder"
              :disabled="statusPop === 2"
              v-else-if="items.scope === 'select'"
              v-model="listData[items.prop]"
            >
              <el-option
                v-for="(item, index) in items.options"
                :key="index"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
            <div v-else-if="items.scope === 'moreInputs'">
              <el-select
                v-model="listData[items.prop]"
                placeholder="请选择"
                style="margin-right: 10px"
                :disabled="statusPop === 2"
              >
                <el-option
                  v-for="(item, index) in items.options"
                  :key="index"
                  :label="item.label"
                  :value="item.value"
                >
                </el-option>
              </el-select>
              <el-input
                style="width: 90px"
                :disabled="statusPop === 2"
                v-model="listData[items.prop2]"
              ></el-input>
              ~
              <el-input
                style="width: 90px"
                :disabled="statusPop === 2"
                v-model="listData[items.prop3]"
              ></el-input>
              元
            </div>
            <div v-else-if="items.scope === 'selectS'">
              <ul class="ulList">
                <li
                  v-for="(item, index) in listData[items.prop]"
                  :key="index"
                  :class="statusPop !== 2 ? 'mar_r' : ''"
                >
                  {{ item }}
                  <i
                    class="el-icon-error clears"
                    @click="clicks(index)"
                    v-if="statusPop !== 2"
                  ></i>
                </li>
                <el-popover placement="top" width="160" v-model="visible">
                  <p style="text-align: center; margin-bottom: 6px">福利标签</p>
                  <el-input
                    size="mini"
                    style="margin-bottom: 6px"
                    v-model="flmsg"
                  ></el-input>
                  <div style="text-align: right; margin: 0">
                    <el-button size="mini" type="text" @click="flmsg = ''"
                      >重置</el-button
                    >
                    <el-button type="primary" size="mini" @click="addflLists"
                      >确定</el-button
                    >
                  </div>
                  <el-button slot="reference" size="mini" v-if="statusPop !== 2"
                    >新增</el-button
                  >
                </el-popover>
                <div style="clear: both"></div>
              </ul>
            </div>
            <el-input
              :disabled="statusPop === 2"
              v-else
              v-model="listData[items.prop]"
            ></el-input>
          </el-form-item>
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button @click="close">取 消</el-button>
        <el-button
          type="primary"
          v-if="statusPop !== 2"
          @click="submit('listData')"
          >确 定</el-button
        >
      </span>
    </el-dialog>
  </div>
</template>

<script>
import searchBox from "@/components/searchBox";
import tableList from "@/components/tableList";
import pagination from "@/components/pagination";
export default {
  components: { searchBox, tableList, pagination },
  data() {
    return {
      visible: false,
      flmsg: "",
      loading: false, //当前表单加载是否加载动画
      navText: {
        title: "职位模板",
        index: 0,
        ch: "条",
        num: true,
        choice: false,
        addHide: false,
        backFatherBtn: {
          status: false,
          title: "未定义",
        },
      },
      //搜索
      formList: [
        {
          label: "公司名称",
          prop: "companyName",
          placeholder: "请输入公司名称",
        },
        {
          label: "岗位名称",
          prop: "job",
          placeholder: "请输入岗位名称",
        },
        {
          label: "状态",
          prop: "status",
          placeholder: "请选择状态",
          scope: "select",
          options: [
            {
              label: "启用",
              value: 1,
            },
            {
              label: "停用",
              value: 0,
            },
          ],
        },
      ],
      // 表单
      tableSet: [
        {
          label: "所属公司",
          prop: "companyName",
          hidden: true,
        },
        {
          label: "岗位名称",
          prop: "job",
          hidden: true,
        },
        {
          label: "薪资",
          prop1: "incomeType",
          prop2: "incomeStart",
          prop3: "incomeEnd",
          hidden: true,
          scope: "Salary",
          width: "200px",
        },
        {
          label: "福利",
          prop: "welfare",
          hidden: true,
        },
        {
          label: "工作职责",
          prop: "duty",
          width: "200px",
          hidden: true,
        },
        {
          label: "任职要求",
          prop: "requirement",
          hidden: true,
          width: "200px",
        },
        {
          label: "工作年限",
          prop: "workingYearsLabel",
          hidden: true,
        },
        {
          label: "最低学历",
          prop: "minimumEduLabel",
          hidden: true,
        },
        {
          label: "专业",
          prop: "major",
          hidden: true,
        },
        {
          label: "状态",
          prop: "status",
          hidden: true,
          scope: "status",
        },
      ],
      tableData: [], //表单数据
      total: 0, //一共多少条
      pageSize: 10, //每页多少条数据
      currentPage: 1, //当前页码
      // 弹窗字段
      listitem: [
        {
          label: "公司名称",
          prop: "companyId",
          scope: "select",
          options: [],
          placeholder: "请输入公司名称",
        },
        {
          label: "岗位名称",
          prop: "job",
          placeholder: "请输入岗位名称",
        },
        {
          label: "岗位薪资",
          prop: "incomeType",
          prop2: "incomeStart",
          prop3: "incomeEnd",
          scope: "moreInputs",
          options: [
            {
              label: "月薪",
              value: 1,
            },
            {
              label: "年薪",
              value: 2,
            },
          ],
        },
        {
          label: "工作职责",
          prop: "duty",
          scope: "textarea",
        },
        {
          label: "任职要求",
          prop: "requirement",
          scope: "textarea",
        },
        {
          label: "福利",
          prop: "welfare",
          scope: "selectS",
        },
        {
          label: "岗位关键词",
          prop: "jobKey",
        },
        {
          label: "工作年限",
          prop: "workingYearsDict",
          scope: "select",
          options: [],
        },
        {
          label: "最低学历要求",
          prop: "minimumEduDict",
          scope: "select",
          options: [],
        },
        {
          label: "专业",
          prop: "major",
        },
        {
          label: "状态",
          prop: "status",
          scope: "radio",
          options: [
            {
              label: "启用",
              value: 1,
            },
            {
              label: "停用",
              value: 0,
            },
          ],
        },
      ],
      //   弹窗数据
      listData: {},
      statusPop: -1,
      dialogVisible: false,
      //表单验证
      rules: {
        companyId: [
          { required: true, message: "请选择公司名称", trigger: "change" },
        ],
        incomeType: [
          { required: true, message: "请选择薪资类型", trigger: "change" },
        ],

        welfare: [
          { required: true, message: "请新增福利标签", trigger: "change" },
        ],
        status: [{ required: true, message: "请选择状态", trigger: "change" }],
        job: [{ required: true, message: "请输入岗位名称", trigger: "blur" }],
        major: [{ required: true, message: "请输入专业", trigger: "blur" }],
        duty: [{ required: true, message: "请输入工作职责", trigger: "blur" }],
        requirement: [
          { required: true, message: "请输入任职要求", trigger: "blur" },
        ],
        workingYearsDict: [
          { required: true, message: "请选择工作年限", trigger: "change" },
        ],
        minimumEduDict: [
          { required: true, message: "请选择最低学历", trigger: "change" },
        ],
      },
    };
  },
  created() {
    this.getDict();
  },
  mounted() {
    this.search();
  },
  methods: {
    clicks(v) {
      this.listData.welfare.splice(v, 1);
    },
    addflLists() {
      this.flmsg = this.flmsg.replace(/^\s*|\s*$/g, "");
      if (!this.flmsg.length) {
        this.$message.error("请输入福利标签");
        return;
      } else {
        this.listData.welfare.push(this.flmsg);
        this.flmsg = "";
        this.visible = false;
      }
    },
    getDict() {
      var arays = []; //学历
      var workYears = []; //工作年限
      var newArrays = []; //学历转换
      var companysArrays = [
        {
          label: this.$store.state.userInfo[0].tenant.tenantName,
          value: 0,
        },
      ]; //公司名称转换
      this.$api.recruitcompanyConlist().then((res) => {
        res.rows.forEach((item, index) => {
          let arrayList = {
            label: item.companyName,
            value: item.companyId,
          };
          companysArrays.push(arrayList);
        });
      });

      var workYearsArrays = []; //工作年限转换
      this.$store.state.UserDict.forEach((item, index) => {
        if (item.dictType == "edu_level") {
          arays.push(item);
        }
        if (item.dictType == "working_years") {
          workYears.push(item);
        }
      });
      arays.forEach((item, index) => {
        let arrayList = {
          label: item.dictLabel,
          value: item.dictCode,
        };
        newArrays.push(arrayList);
      });
      workYears.forEach((item, index) => {
        let arrayList = {
          label: item.dictLabel,
          value: item.dictCode,
        };
        workYearsArrays.push(arrayList);
      });
      for (let i = 0; i < this.listitem.length; i++) {
        if (this.listitem[i].label === "最低学历要求") {
          this.listitem[i].options = newArrays;
        }
        if (this.listitem[i].label === "工作年限") {
          this.listitem[i].options = workYearsArrays;
        }
        if (this.listitem[i].label === "公司名称") {
          this.listitem[i].options = companysArrays;
        }
      }
    },
    search(v) {
      this.loading = true;
      if (v === undefined) {
        v = {
          pageSize: this.pageSize,
          pageNum: this.currentPage,
        };
      }
      var data = {
        companyName: v.companyName,
        job: v.job,
        status: v.status === undefined ? "0,1" : v.status,
        pageSize: this.pageSize,
        pageNum: this.currentPage,
      };
      this.$api.recruittemplatelist(data).then((res) => {
        this.tableData = res.rows;
        this.total = res.total;
        this.navText.index = res.total;
      });
      this.loading = false;
    },
    init() {
      this.search();
    },
    del(v) {
      var self = this;
      this.$confirm("此操作将删除该字典类型, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          var datas = {
            id: v.id,
            status: -1,
          };
          self.$api.editrecruittemplate(datas).then((res) => {
            if (res.code === 200) {
              self.$message.success("删除成功");
              self.search();
            }
          });
        })
        .catch(() => {});
    },
    addClick(v, int) {
      if (v === undefined) {
        this.statusPop = 1;
        this.listData = {
          welfare: [],
        };
      } else {
        this.statusPop = int;
        this.$api.recruittemplateid(v.id).then((res) => {
          res.data.minimumEduDict = Number(res.data.minimumEduDict);
          res.data.workingYearsDict = Number(res.data.workingYearsDict);
          res.data.welfare = res.data.welfare.split(",");
          this.listData = res.data;
        });
      }
      this.dialogVisible = true;
    },
    submit(formName) {
      var self = this;
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var tests = /(^[1-9]\d*(\.\d{1,2})?$)|(^0(\.\d{1,2})?$)/;
          if (!tests.test(self.listData.incomeStart)) {
            self.$message.error("请输入正确薪资价格");
            return;
          }
          if (!tests.test(self.listData.incomeEnd)) {
            self.$message.error("请输入正确薪资价格");
            return;
          }
          if (
            Number(self.listData.incomeStart) > Number(self.listData.incomeEnd)
          ) {
            self.$message.error("请输入正确薪资范围格式");
            return;
          }
          this.rulesTableSumbit();
        } else {
          return false;
        }
      });
    },
    rulesTableSumbit() {
      var self = this;
      var dataLists = {};
      dataLists = JSON.parse(JSON.stringify(this.listData));
      switch (dataLists.workingYearsDict) {
        case "0":
          dataLists.workingYearsStart = 0;
          dataLists.workingYearsEnd = 0;
          break;
        case "1":
          dataLists.workingYearsStart = 0;
          dataLists.workingYearsEnd = 1;
          break;
        case "2":
          dataLists.workingYearsStart = 1;
          dataLists.workingYearsEnd = 3;
          break;
        case "3":
          dataLists.workingYearsStart = 3;
          dataLists.workingYearsEnd = 5;
          break;
        case "4":
          dataLists.workingYearsStart = 5;
          dataLists.workingYearsEnd = 10;
          break;
        case "5":
          dataLists.workingYearsStart = 10;
          dataLists.workingYearsEnd = 0;
          break;
        default:
          break;
      }
      if (dataLists.welfare.length) {
        dataLists.welfare = dataLists.welfare.toString();
      }
      if (this.statusPop === 1) {
        this.$api.addrecruittemplate(dataLists).then((res) => {
          if (res.code === 200) {
            this.$message.success("新增成功");
            this.dialogVisible = false;
            this.search();
          }
        });
      }
      if (this.statusPop === 0) {
        this.$api.editrecruittemplate(dataLists).then((res) => {
          if (res.code === 200) {
            this.$message.success("修改成功");
            this.dialogVisible = false;
            this.search();
          }
        });
      }
      this.$refs["listData"].resetFields();
    },
    close() {
      if (this.statusPop === 2) {
        this.dialogVisible = false;
        return;
      }
      this.$confirm("是否关闭该窗口", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.$refs["listData"].resetFields();
          this.dialogVisible = false;
        })
        .catch(() => {});
    },
    handleSizeChange(v) {
      this.pageSize = v;
      this.currentPage = 1;
      this.search();
    },
    handleCurrentChange(v) {
      this.currentPage = v;
      this.search();
    },
  },
};
</script>

<style lang="less" scoped>
.ulList {
  li {
    float: left;
    border-radius: 6px;
    border: 1px solid #409eff;
    color: #409eff;
    padding: 0px 13px;
    height: 36px;
    line-height: 36px;
    text-align: center;
    margin-bottom: 10px;
    margin-right: 14px;
    position: relative;
    .clears {
      position: absolute;
      top: 4px;
      right: 4px;
      color: red;
      cursor: pointer;
    }
  }
  .mar_r {
    padding-right: 20px !important;
  }
}
/deep/.el-button {
  border-radius: 8px;
}
/deep/.el-dialog {
  border-radius: 8px;
  .el-dialog__header {
    padding: 0;
    .hearders {
      height: 40px;
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 0px 18px 0px 20px;
      border-bottom: 1px solid #e2e2e2;
      .leftTitle {
        font-size: 14px;
        font-weight: bold;
        color: #2f4378;
      }
      .rightBoxs {
        display: flex;
        align-items: center;
        img {
          width: 14px;
          height: 14px;
          margin-left: 13px;
          cursor: pointer;
        }
      }
    }
  }
  .el-dialog__footer {
    padding: 0;
    .dialog-footer {
      padding: 0px 40px;
      height: 70px;
      border-top: 1px solid #e2e2e2;
      display: flex;
      align-items: center;
      justify-content: flex-end;
    }
  }
}
.imgBox {
  width: 100%;
  // height: 210px;
  border: 1px solid #e2e2e2;
  border-radius: 8px;
  padding: 8px 8px 3px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .imgLabel {
    flex: 1;
    width: 100%;
    border: 1px dotted #e2e2e2;
    color: #999;
    font-size: 14px;
    cursor: pointer;
    border-radius: 8px;
    .msPhoto {
      display: flex;
      justify-content: center;
      align-items: center;
      max-width: 100%;
      max-height: 270px;
      img {
        max-width: 100%;
        max-height: 270px;
      }
    }
    .imgbbx {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      i {
        font-weight: bold;
        margin: 14px 0;
        font-size: 24px;
      }
    }
  }
  p {
    margin: 5px 0px;
  }
}
</style>

